loops equ 10000                 ;number of times to test triangle speed
log_loops equ 4                 ;log10(loops)
maxprecalc equ 10000000         ;allow 10'000'000 cycles precalculation time
rdtsc equ dw 310fh

.386p
.model flat
.stack 100h
.code

extrn drawtri:near              ;the 2 external procedures
extrn precalc:near


include io.mac
include tridat.asm              ;always use the same triangle set for
                                ;a fair performance check
                                ;(i will use another table for the final
                                ;speed measurements, so don't go start
                                ;hardcoding :)

public vx,vy,flatcolor,videoptr
cheater db 'You''re precalcing too long!',13,10,'$'
benchmsg db ' Cycles used for triangle drawing ($'
loopmesg db ' loops)',13,10,'$'
mhz db 'MHz machine',13,10,'$'
komma db '.$'
zero db '0$'
loser db 'You need a Pentium! Try sending your entry to a friend who has one',13,10,'$'
vx dd 0,0,0
vy dd 0,0,0
flatcolor db 15
starttick_l dd ?
starttick_h dd ?
endtick dd ?
overhead dd ?
videoptr dd ?

getMHz proc
 pushad

 mov edi,46ch
 mov ax,1
 mov es:[edi],ax
@waitfortick:
 mov bx,ax
 mov ax,es:[di]
 cmp ax,bx
 je @waitfortick

 rdtsc

 mov esi,eax
 mov ax,1
 mov es:[di],ax
@waitfortick2:
 mov bx,ax
 mov ax,es:[di]
 cmp ax,bx
 je @waitfortick2
 rdtsc
 sub eax,esi
 ;mov ecx,eax
 mov ecx,54945
 cdq
 idiv ecx
 mov ecx,eax
 call write_ecx
 mov ah,9
 lea edx,mhz
 int 21h
 popad

 ret
endp
int06handler proc
 mov ah,9
 lea edx,loser
 int 21h
 exitcode
endp

detpenti proc
 mov ax,204h
 mov bl,6
 int 31h
 push edx
 push ecx

 mov cx,cs
 mov ax,205h
 mov bl,6
 mov edx,offset int06handler
 int 31h

 rdtsc

 pop ecx
 pop edx
 mov ax,205h
 int 31h

 ret
endp
calcoh proc
 mov eax,ds:starttick_l               ;cache ready...
 mov eax,ds:starttick_h               ;cache ready...
 rdtsc
 mov starttick_l,eax
 mov starttick_h,edx
 pushad
 popad
 rdtsc
 sub eax,starttick_l
 mov overhead,eax
 ret
endp

start:
    mov ax,0ee02h
    int 31h
    neg ebx
    add ebx,0a0000h
    mov videoptr,ebx


    mov ax,0ee00h
    int 31h
    push bx
    pop es

    call detpenti
    call calcoh
    mov ax,13h
    int 10h


    rdtsc
    mov starttick_l,eax
    pusha
    call precalc
    popa
    rdtsc
    sub eax,starttick_l
    cmp eax,maxprecalc
    jbe @pcok
     mov ax,3
     int 10h
     mov ah,9
     lea edx,cheater
     int 21h
     exitcode
    @pcok:


    xor ecx,ecx
    xor edi,edi
    mov ebx,loops
    xor esi,esi
    out 70h,al
    cli

@loop:
    xor eax,eax
    mov ax,ds:[x_coords+esi*2]
    mov ds:[vx+0],eax
    mov ax,ds:[x_coords+esi*2+2]
    mov ds:[vx+4],eax
    mov ax,ds:[x_coords+esi*2+4]
    mov ds:[vx+8],eax


    mov ax,ds:[y_coords+esi*2]
    mov ds:[vy+0],eax
    mov ax,ds:[y_coords+esi*2+2]
    mov ds:[vy+8],eax
    mov ax,ds:[y_coords+esi*2+4]
    mov ds:[vy+4],eax

    mov al,byte ptr ds:[x_coords+esi]
    mov flatcolor,al

    mov eax,ds:starttick_l               ;cache ready...
    mov eax,ds:starttick_h               ;cache ready...
    rdtsc
    mov starttick_l,eax
    mov starttick_h,edx
    pushad

    call drawtri
    popad
    rdtsc
    sub eax,starttick_l
    adc edi,0
    add ecx,eax
    sub ecx,overhead
    sbb edi,0
    inc esi
    cmp esi,10000
    jbe @dontrunc
     xor esi,esi
@dontrunc:
    dec ebx
    jnz @loop


    sti
    mov al,80h
    out 70h,al
    mov ax,3
    int 10h

    xchg eax,ecx
    xchg edx,edi
    mov ecx,loops
    idiv ecx
    xchg eax,ecx

    call write_ecxedx


    mov ah,9
    lea edx,benchmsg
    int 21h

    mov ecx,loops
    call write_ecx
    mov ah,9
    lea edx,loopmesg
    int 21h


    call getMHz
    exitcode
end start
